#! /usr/bin/perl

## Put here your local delivery agent (see sendmail.cf)
$mail = "/usr/lib/tulp/queue";

## Path to Sendmail
$sendmail = "/usr/sbin/sendmail";

## Who gets the rejected messages
$mgr = "listman";

## Should the UNIX From line be removed ?  True on many systems.
$nofrom = 0;

## Regexps for the unwanted strings.
@avoid_hdr = (
	'help',
	'ind(ex)?',
	'lists?',
	'(please\s+)?(add|unsub|remove|del|sub(\s|scribe)?|sign?o?f?f?)',
	'rev(iew)?\s+\S+'
             );
@avoid_msg = (
	'help',
	'ind(ex)?',
	'lists?',
	'(please\s+)?(add|unsub|remove|del|sub(\s|scribe)?|sign?o?f?f?)',
	'rev(iew)?\s+\S+'
             );

$arg = $ARGV[0];
@ARGV = ();

## Paragraph mode
$/ = ""; 
$* =  1;

## Get the header.
$hdr = <>;
$hdr =~ s/^From\s+.+\n//i if ($nofrom == 1);

## Get the entire message
$* = 0;
$/ = "\n";
while (<>) {
   push(@line, $_);
}


## If more than 10 lines or to listserv then it should be okay.
&putMsg() if ($arg =~ /^listserv$/i);
&putMsg() if ($#line > 10);

$nhdr = $hdr;

$/ = ""; 
$* =  1;

$nhdr =~ s/\n\s+//g;

$from = $1 if ($hdr =~ /^From:\s+(.+)\s*$/i);
$subject = $1 if ($hdr =~ /^Subject:\s+(.+)\s*$/i);

if ($subject) {
   foreach $avoid (@avoid_hdr) {
      if ($subject =~ /^\s*($avoid)\s*/i) {  ## We have a suspicious header
         &mailMsg();
      }
   }
}

$* = 0;
$/ = "\n";

foreach $line (@line) {
   foreach $avoid (@avoid_msg) {
      if ($line =~ /^\s*($avoid)\s*/i) {  ## We have a suspicious header
         &mailMsg();
      }
   }
}

&putMsg();
exit(0);

sub putMsg {
   open(STDOUT, "| $mail $arg");
   print $hdr;
   print @line;
   close(STDOUT);
   exit(0);
}

sub mailMsg {
   $from = $mgr if (!$from);
   open(STDOUT, "| $sendmail -f listserv-request -t");
   print "To: $from\n";
   print "Subject: [listserv]: Erreur d'aiguillage?\n";
   print "Bcc: $mgr\n\n";
   print "
The message you posted to the mailinglist $arg seems
to contain commands for the mailinglist robot like:
	subscribe, signoff, help, index, get...

Any commands for the mailinglist robot should be send to the user
listserv on this system. If your messages was not properly interpreted
as a mailinglist robot command but should indeed be delivered to the
mailinglist you will have to resend your message.

We humbly ack your pardon for this intrusion and hope you will enjoy
our mailinglist(s).

Regards,
listserv

------ Begin of your message --------
X-Listserv-To: $arg\n";
   print $hdr;
   print @line;
   print "------- End of your message ---------\n";
   exit(0);
}
